/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.275 Revision 1.377
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.275 2007/02/17 00:17:39 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.377 2012/01/03 08:45:36 jlec Exp $
4#
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
17
18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
12inherit multilib portability 21inherit multilib portability user
13 22
14DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
15 24
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
18# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
19# must be an integer greater than zero. 28# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 34epause() {
22 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23} 36}
24 37
25# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
26# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
27# don't beep. 40# @DESCRIPTION:
28# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
29ebeep() { 45ebeep() {
30 local n 46 local n
31 if [[ -z ${EBEEP_IGNORE} ]] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
32 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
33 echo -ne "\a" 49 echo -ne "\a"
36 sleep 1 52 sleep 1
37 done 53 done
38 fi 54 fi
39} 55}
40 56
41# This function generate linker scripts in /usr/lib for dynamic 57else
42# libs in /lib. This is to fix linking problems when you have 58
43# the .so in /lib, and the .a in /usr/lib. What happens is that 59ebeep() {
44# in some cases when linking dynamic, the .a in /usr/lib is used 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
45# instead of the .so in /lib due to gcc/libtool tweaking ld's 61}
46# library search path. This cause many builds to fail. 62
47# See bug #4411 for more info. 63epause() {
48# 64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
49# To use, simply call: 65}
50# 66
51# gen_usr_ldscript libfoo.so
52#
53# Note that you should in general use the unversioned name of
54# the library, as ldconfig should usually update it correctly
55# to point to the latest version of the library present.
56#
57# <azarah@gentoo.org> (26 Oct 2002)
58#
59gen_usr_ldscript() {
60 if [[ $(type -t _tc_gen_usr_ldscript) == "function" ]] ; then
61 _tc_gen_usr_ldscript "$@"
62 return $?
63 fi 67fi
64 68
65 ewarn "QA Notice: Please upgrade your ebuild to use toolchain-funcs" 69# @FUNCTION: eqawarn
66 ewarn "QA Notice: rather than gen_usr_ldscript() from eutils" 70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
67 81
68 local lib libdir=$(get_libdir) 82# @FUNCTION: ecvs_clean
69 # Just make sure it exists 83# @USAGE: [list of dirs]
70 dodir /usr/${libdir} 84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
71 92
72 for lib in "${@}" ; do 93# @FUNCTION: esvn_clean
73 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 94# @USAGE: [list of dirs]
74 /* GNU ld script 95# @DESCRIPTION:
75 Since Gentoo has critical dynamic libraries 96# Remove .svn directories recursiveley. Useful when a source tarball contains
76 in /lib, and the static versions in /usr/lib, 97# internal Subversion directories. Defaults to $PWD.
77 we need to have a "fake" dynamic lib in /usr/lib, 98esvn_clean() {
78 otherwise we run into linking problems. 99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
79 102
80 See bug http://bugs.gentoo.org/4411 for more info. 103# @FUNCTION: estack_push
81 */ 104# @USAGE: <stack> [items to push]
82 GROUP ( /${libdir}/${lib} ) 105# @DESCRIPTION:
83 END_LDSCRIPT 106# Push any number of items onto the specified stack. Pick a name that
84 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
85 done 115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
86} 121}
87 122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
88 131
89# Default directory where patches are located 132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
184}
185
186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 local s
218 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
219 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
220}
221
222# @VARIABLE: EPATCH_SOURCE
223# @DESCRIPTION:
224# Default directory to search for patches.
90EPATCH_SOURCE="${WORKDIR}/patch" 225EPATCH_SOURCE="${WORKDIR}/patch"
91# Default extension for patches 226# @VARIABLE: EPATCH_SUFFIX
227# @DESCRIPTION:
228# Default extension for patches (do not prefix the period yourself).
92EPATCH_SUFFIX="patch.bz2" 229EPATCH_SUFFIX="patch.bz2"
230# @VARIABLE: EPATCH_OPTS
231# @DESCRIPTION:
93# Default options for patch 232# Default options for patch:
233# @CODE
94# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 234# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
95# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 235# --no-backup-if-mismatch - do not leave .orig files behind
96# Set -E to automatically remove empty files. 236# -E - automatically remove empty files
237# @CODE
97EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 238EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
239# @VARIABLE: EPATCH_EXCLUDE
240# @DESCRIPTION:
98# List of patches not to apply. Not this is only file names, 241# List of patches not to apply. Note this is only file names,
99# and not the full path .. 242# and not the full path. Globs accepted.
100EPATCH_EXCLUDE="" 243EPATCH_EXCLUDE=""
244# @VARIABLE: EPATCH_SINGLE_MSG
245# @DESCRIPTION:
101# Change the printed message for a single patch. 246# Change the printed message for a single patch.
102EPATCH_SINGLE_MSG="" 247EPATCH_SINGLE_MSG=""
248# @VARIABLE: EPATCH_MULTI_MSG
249# @DESCRIPTION:
103# Change the printed message for multiple patches. 250# Change the printed message for multiple patches.
104EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 251EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
105# Force applying bulk patches even if not following the style: 252# @VARIABLE: EPATCH_FORCE
106# 253# @DESCRIPTION:
107# ??_${ARCH}_foo.${EPATCH_SUFFIX} 254# Only require patches to match EPATCH_SUFFIX rather than the extended
108# 255# arch naming style.
109EPATCH_FORCE="no" 256EPATCH_FORCE="no"
110 257
111# This function is for bulk patching, or in theory for just one 258# @FUNCTION: epatch
112# or two patches. 259# @USAGE: [patches] [dirs of patches]
260# @DESCRIPTION:
261# epatch is designed to greatly simplify the application of patches. It can
262# process patch files directly, or directories of patches. The patches may be
263# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
264# the -p option as epatch will automatically attempt -p0 to -p5 until things
265# apply successfully.
113# 266#
114# It should work with .bz2, .gz, .zip and plain text patches. 267# If you do not specify any options, then epatch will default to the directory
115# Currently all patches should be the same format. 268# specified by EPATCH_SOURCE.
116# 269#
117# You do not have to specify '-p' option to patch, as it will 270# When processing directories, epatch will apply all patches that match:
118# try with -p0 to -p5 until it succeed, or fail at -p5. 271# @CODE
119# 272# if ${EPATCH_FORCE} != "yes"
120# Above EPATCH_* variables can be used to control various defaults,
121# bug they should be left as is to ensure an ebuild can rely on
122# them for.
123#
124# Patches are applied in current directory.
125#
126# Bulk Patches should preferibly have the form of:
127#
128# ??_${ARCH}_foo.${EPATCH_SUFFIX} 273# ??_${ARCH}_foo.${EPATCH_SUFFIX}
274# else
275# *.${EPATCH_SUFFIX}
276# @CODE
277# The leading ?? are typically numbers used to force consistent patch ordering.
278# The arch field is used to apply patches only for the host architecture with
279# the special value of "all" means apply for everyone. Note that using values
280# other than "all" is highly discouraged -- you should apply patches all the
281# time and let architecture details be detected at configure/compile time.
129# 282#
130# For example: 283# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
284# for patches to apply.
131# 285#
132# 01_all_misc-fix.patch.bz2 286# Refer to the other EPATCH_xxx variables for more customization of behavior.
133# 02_sparc_another-fix.patch.bz2
134#
135# This ensures that there are a set order, and you can have ARCH
136# specific patches.
137#
138# If you however give an argument to epatch(), it will treat it as a
139# single patch that need to be applied if its a file. If on the other
140# hand its a directory, it will set EPATCH_SOURCE to this.
141#
142# <azarah@gentoo.org> (10 Nov 2002)
143#
144epatch() { 287epatch() {
145 _epatch_draw_line() { 288 _epatch_draw_line() {
289 # create a line of same length as input string
146 [[ -z $1 ]] && set "$(printf "%65s" '')" 290 [[ -z $1 ]] && set "$(printf "%65s" '')"
147 echo "${1//?/=}" 291 echo "${1//?/=}"
148 } 292 }
149 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
150 local PIPE_CMD=""
151 local STDERR_TARGET="${T}/$$.out"
152 local PATCH_TARGET="${T}/$$.patch"
153 local PATCH_SUFFIX=""
154 local SINGLE_PATCH="no"
155 local x=""
156 293
157 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 294 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
158 295
159 if [ "$#" -gt 1 ] 296 # Let the rest of the code process one user arg at a time --
160 then 297 # each arg may expand into multiple patches, and each arg may
298 # need to start off with the default global EPATCH_xxx values
299 if [[ $# -gt 1 ]] ; then
161 local m="" 300 local m
162 for m in "$@" ; do 301 for m in "$@" ; do
163 epatch "${m}" 302 epatch "${m}"
164 done 303 done
165 return 0 304 return 0
166 fi 305 fi
167 306
168 if [ -n "$1" -a -f "$1" ] 307 local SINGLE_PATCH="no"
169 then 308 # no args means process ${EPATCH_SOURCE}
309 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
310
311 if [[ -f $1 ]] ; then
170 SINGLE_PATCH="yes" 312 SINGLE_PATCH="yes"
171 313 set -- "$1"
172 local EPATCH_SOURCE="$1" 314 # Use the suffix from the single patch (localize it); the code
315 # below will find the suffix for us
173 local EPATCH_SUFFIX="${1##*\.}" 316 local EPATCH_SUFFIX=$1
174 317
175 elif [ -n "$1" -a -d "$1" ] 318 elif [[ -d $1 ]] ; then
176 then 319 # Some people like to make dirs of patches w/out suffixes (vim)
177 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 320 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
178 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 321
322 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
323 # Re-use EPATCH_SOURCE as a search dir
324 epatch "${EPATCH_SOURCE}/$1"
325 return $?
326
327 else
328 # sanity check ... if it isn't a dir or file, wtf man ?
329 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
330 echo
331 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
332 eerror
333 eerror " ${EPATCH_SOURCE}"
334 eerror " ( ${EPATCH_SOURCE##*/} )"
335 echo
336 die "Cannot find \$EPATCH_SOURCE!"
337 fi
338
339 local PIPE_CMD
340 case ${EPATCH_SUFFIX##*\.} in
341 xz) PIPE_CMD="xz -dc" ;;
342 lzma) PIPE_CMD="lzma -dc" ;;
343 bz2) PIPE_CMD="bzip2 -dc" ;;
344 gz|Z|z) PIPE_CMD="gzip -dc" ;;
345 ZIP|zip) PIPE_CMD="unzip -p" ;;
346 *) ;;
347 esac
348
349 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
350
351 local x
352 for x in "$@" ; do
353 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
354 # didn't match anything, ignore continue on
355 [[ ! -f ${x} ]] && continue
356
357 local patchname=${x##*/}
358
359 # Apply single patches, or forced sets of patches, or
360 # patches with ARCH dependant names.
361 # ???_arch_foo.patch
362 # Else, skip this input altogether
363 local a=${patchname#*_} # strip the ???_
364 a=${a%%_*} # strip the _foo.patch
365 if ! [[ ${SINGLE_PATCH} == "yes" || \
366 ${EPATCH_FORCE} == "yes" || \
367 ${a} == all || \
368 ${a} == ${ARCH} ]]
179 then 369 then
180 local EPATCH_SOURCE="$1/*" 370 continue
371 fi
372
373 # Let people filter things dynamically
374 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
375 # let people use globs in the exclude
376 eshopts_push -o noglob
377
378 local ex
379 for ex in ${EPATCH_EXCLUDE} ; do
380 if [[ ${patchname} == ${ex} ]] ; then
381 eshopts_pop
382 continue 2
383 fi
384 done
385
386 eshopts_pop
387 fi
388
389 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
390 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
391 einfo "${EPATCH_SINGLE_MSG}"
392 else
393 einfo "Applying ${patchname} ..."
394 fi
181 else 395 else
182 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 396 einfo " ${patchname} ..."
183 fi 397 fi
184 else 398
185 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 399 # most of the time, there will only be one run per unique name,
186 then 400 # but if there are more, make sure we get unique log filenames
187 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 401 local STDERR_TARGET="${T}/${patchname}.out"
188 then 402 if [[ -e ${STDERR_TARGET} ]] ; then
189 EPATCH_SOURCE="$1" 403 STDERR_TARGET="${T}/${patchname}-$$.out"
404 fi
405
406 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
407
408 # Decompress the patch if need be
409 local count=0
410 local PATCH_TARGET
411 if [[ -n ${PIPE_CMD} ]] ; then
412 PATCH_TARGET="${T}/$$.patch"
413 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
414
415 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
416 echo
417 eerror "Could not extract patch!"
418 #die "Could not extract patch!"
419 count=5
420 break
190 fi 421 fi
422 else
423 PATCH_TARGET=${x}
424 fi
191 425
426 # Check for absolute paths in patches. If sandbox is disabled,
427 # people could (accidently) patch files in the root filesystem.
428 # Or trigger other unpleasantries #237667. So disallow -p0 on
429 # such patches.
430 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
431 if [[ -n ${abs_paths} ]] ; then
432 count=1
433 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
434 fi
435 # Similar reason, but with relative paths.
436 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
437 if [[ -n ${rel_paths} ]] ; then
438 eqawarn "QA Notice: Your patch uses relative paths '../'."
439 eqawarn " In the future this will cause a failure."
440 eqawarn "${rel_paths}"
441 fi
442
443 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
444 while [[ ${count} -lt 5 ]] ; do
445 # Generate some useful debug info ...
446 (
447 _epatch_draw_line "***** ${patchname} *****"
192 echo 448 echo
193 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 449 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
450 echo
451 _epatch_draw_line "***** ${patchname} *****"
452 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
453 ret=$?
454 echo
455 echo "patch program exited with status ${ret}"
456 exit ${ret}
457 ) >> "${STDERR_TARGET}"
458
459 if [ $? -eq 0 ] ; then
460 (
461 _epatch_draw_line "***** ${patchname} *****"
462 echo
463 echo "ACTUALLY APPLYING ${patchname} ..."
464 echo
465 _epatch_draw_line "***** ${patchname} *****"
466 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
467 ret=$?
468 echo
469 echo "patch program exited with status ${ret}"
470 exit ${ret}
471 ) >> "${STDERR_TARGET}"
472
473 if [ $? -ne 0 ] ; then
474 echo
475 eerror "A dry-run of patch command succeeded, but actually"
476 eerror "applying the patch failed!"
477 #die "Real world sux compared to the dreamworld!"
478 count=5
479 fi
480 break
481 fi
482
483 : $(( count++ ))
484 done
485
486 # if we had to decompress the patch, delete the temp one
487 if [[ -n ${PIPE_CMD} ]] ; then
488 rm -f "${PATCH_TARGET}"
489 fi
490
491 if [[ ${count} -ge 5 ]] ; then
492 echo
493 eerror "Failed Patch: ${patchname} !"
494 eerror " ( ${PATCH_TARGET} )"
194 eerror 495 eerror
195 eerror " ${EPATCH_SOURCE}" 496 eerror "Include in your bugreport the contents of:"
196 eerror " ( ${EPATCH_SOURCE##*/} )" 497 eerror
498 eerror " ${STDERR_TARGET}"
197 echo 499 echo
198 die "Cannot find \$EPATCH_SOURCE!"
199 fi
200
201 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
202 fi
203
204 case ${EPATCH_SUFFIX##*\.} in
205 bz2)
206 PIPE_CMD="bzip2 -dc"
207 PATCH_SUFFIX="bz2"
208 ;;
209 gz|Z|z)
210 PIPE_CMD="gzip -dc"
211 PATCH_SUFFIX="gz"
212 ;;
213 ZIP|zip)
214 PIPE_CMD="unzip -p"
215 PATCH_SUFFIX="zip"
216 ;;
217 *)
218 PIPE_CMD="cat"
219 PATCH_SUFFIX="patch"
220 ;;
221 esac
222
223 if [ "${SINGLE_PATCH}" = "no" ]
224 then
225 einfo "${EPATCH_MULTI_MSG}"
226 fi
227 for x in ${EPATCH_SOURCE}
228 do
229 # New ARCH dependant patch naming scheme ...
230 #
231 # ???_arch_foo.patch
232 #
233 if [ -f ${x} ] && \
234 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
235 [ "${EPATCH_FORCE}" = "yes" ])
236 then
237 local count=0
238 local popts="${EPATCH_OPTS}"
239 local patchname=${x##*/}
240
241 if [ -n "${EPATCH_EXCLUDE}" ]
242 then
243 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
244 then
245 continue
246 fi
247 fi
248
249 if [ "${SINGLE_PATCH}" = "yes" ]
250 then
251 if [ -n "${EPATCH_SINGLE_MSG}" ]
252 then
253 einfo "${EPATCH_SINGLE_MSG}"
254 else
255 einfo "Applying ${patchname} ..."
256 fi
257 else
258 einfo " ${patchname} ..."
259 fi
260
261 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263
264 # Allow for prefix to differ ... im lazy, so shoot me :/
265 while [ "${count}" -lt 5 ]
266 do
267 # Generate some useful debug info ...
268 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
269 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270
271 if [ "${PATCH_SUFFIX}" != "patch" ]
272 then
273 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 else
276 PATCH_TARGET="${x}"
277 fi
278
279 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
281
282 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284
285 if [ "${PATCH_SUFFIX}" != "patch" ]
286 then
287 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
288 then
289 echo
290 eerror "Could not extract patch!"
291 #die "Could not extract patch!"
292 count=5
293 break
294 fi
295 fi
296
297 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
298 then
299 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
301 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
303 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
304
305 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
306 _epatch_assert
307
308 if [ "$?" -ne 0 ]
309 then
310 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
311 echo
312 eerror "A dry-run of patch command succeeded, but actually"
313 eerror "applying the patch failed!"
314 #die "Real world sux compared to the dreamworld!"
315 count=5
316 fi
317
318 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
319
320 break
321 fi
322
323 count=$((count + 1))
324 done
325
326 if [ "${PATCH_SUFFIX}" != "patch" ]
327 then
328 rm -f ${PATCH_TARGET}
329 fi
330
331 if [ "${count}" -eq 5 ]
332 then
333 echo
334 eerror "Failed Patch: ${patchname} !"
335 eerror " ( ${PATCH_TARGET} )"
336 eerror
337 eerror "Include in your bugreport the contents of:"
338 eerror
339 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
340 echo
341 die "Failed Patch: ${patchname}!" 500 die "Failed Patch: ${patchname}!"
342 fi 501 fi
343 502
344 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 503 # if everything worked, delete the patch log
345 504 rm -f "${STDERR_TARGET}"
346 eend 0 505 eend 0
347 fi
348 done 506 done
349 if [ "${SINGLE_PATCH}" = "no" ] 507
350 then 508 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
351 einfo "Done with patching" 509 : # everything worked
510}
511
512# @FUNCTION: epatch_user
513# @USAGE:
514# @DESCRIPTION:
515# Applies user-provided patches to the source tree. The patches are
516# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
517# of these three directories to exist will be the one to use, ignoring
518# any more general directories which might exist as well.
519#
520# User patches are intended for quick testing of patches without ebuild
521# modifications, as well as for permanent customizations a user might
522# desire. Obviously, there can be no official support for arbitrarily
523# patched ebuilds. So whenever a build log in a bug report mentions that
524# user patches were applied, the user should be asked to reproduce the
525# problem without these.
526#
527# Not all ebuilds do call this function, so placing patches in the
528# stated directory might or might not work, depending on the package and
529# the eclasses it inherits and uses. It is safe to call the function
530# repeatedly, so it is always possible to add a call at the ebuild
531# level. The first call is the time when the patches will be
532# applied.
533#
534# Ideally, this function should be called after gentoo-specific patches
535# have been applied, so that their code can be modified as well, but
536# before calls to e.g. eautoreconf, as the user patches might affect
537# autotool input files as well.
538epatch_user() {
539 [[ $# -ne 0 ]] && die "epatch_user takes no options"
540
541 # Allow multiple calls to this function; ignore all but the first
542 local applied="${T}/epatch_user.applied"
543 [[ -e ${applied} ]] && return 2
544
545 # don't clobber any EPATCH vars that the parent might want
546 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
547 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
548 EPATCH_SOURCE=${base}/${CTARGET}/${check}
549 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
550 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
551 if [[ -d ${EPATCH_SOURCE} ]] ; then
552 EPATCH_SOURCE=${EPATCH_SOURCE} \
553 EPATCH_SUFFIX="patch" \
554 EPATCH_FORCE="yes" \
555 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
556 epatch
557 echo "${EPATCH_SOURCE}" > "${applied}"
558 return 0
352 fi 559 fi
560 done
561 echo "none" > "${applied}"
562 return 1
353} 563}
354 564
565# @FUNCTION: emktemp
566# @USAGE: [temp dir]
567# @DESCRIPTION:
355# Cheap replacement for when debianutils (and thus mktemp) 568# Cheap replacement for when debianutils (and thus mktemp)
356# does not exist on the users system 569# does not exist on the users system.
357# vapier@gentoo.org
358#
359# Takes just 1 optional parameter (the directory to create tmpfile in)
360emktemp() { 570emktemp() {
361 local exe="touch" 571 local exe="touch"
362 [[ $1 == -d ]] && exe="mkdir" && shift 572 [[ $1 == -d ]] && exe="mkdir" && shift
363 local topdir=$1 573 local topdir=$1
364 574
366 [[ -z ${T} ]] \ 576 [[ -z ${T} ]] \
367 && topdir="/tmp" \ 577 && topdir="/tmp" \
368 || topdir=${T} 578 || topdir=${T}
369 fi 579 fi
370 580
371 if [[ -z $(type -p mktemp) ]] ; then 581 if ! type -P mktemp > /dev/null ; then
582 # system lacks `mktemp` so we have to fake it
372 local tmp=/ 583 local tmp=/
373 while [[ -e ${tmp} ]] ; do 584 while [[ -e ${tmp} ]] ; do
374 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 585 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
375 done 586 done
376 ${exe} "${tmp}" || ${exe} -p "${tmp}" 587 ${exe} "${tmp}" || ${exe} -p "${tmp}"
377 echo "${tmp}" 588 echo "${tmp}"
378 else 589 else
590 # the args here will give slightly wierd names on BSD,
591 # but should produce a usable file on all userlands
379 if [[ ${exe} == "touch" ]] ; then 592 if [[ ${exe} == "touch" ]] ; then
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -p "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -t tmp 593 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
383 else 594 else
384 [[ ${USERLAND} == "GNU" ]] \
385 && mktemp -d "${topdir}" \
386 || TMPDIR="${topdir}" mktemp -dt tmp 595 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
387 fi
388 fi
389}
390
391# Small wrapper for getent (Linux), nidump (Mac OS X),
392# and pw (FreeBSD) used in enewuser()/enewgroup()
393# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
394# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
395#
396# egetent(database, key)
397egetent() {
398 case ${CHOST} in
399 *-darwin*)
400 case "$2" in
401 *[!0-9]*) # Non numeric
402 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
403 ;;
404 *) # Numeric
405 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
406 ;;
407 esac
408 ;;
409 *-freebsd*|*-dragonfly*)
410 local opts action="user"
411 [[ $1 == "passwd" ]] || action="group"
412
413 # lookup by uid/gid
414 if [[ $2 == [[:digit:]]* ]] ; then
415 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
416 fi
417
418 pw show ${action} ${opts} "$2" -q
419 ;;
420 *-netbsd*|*-openbsd*)
421 grep "$2:\*:" /etc/$1
422 ;;
423 *)
424 type -p nscd >& /dev/null && nscd -i "$1"
425 getent "$1" "$2"
426 ;;
427 esac
428}
429
430# Simplify/standardize adding users to the system
431# vapier@gentoo.org
432#
433# enewuser(username, uid, shell, homedir, groups, extra options)
434#
435# Default values if you do not specify any:
436# username: REQUIRED !
437# uid: next available (see useradd(8))
438# note: pass -1 to get default behavior
439# shell: /bin/false
440# homedir: /dev/null
441# groups: none
442# extra: comment of 'added by portage for ${PN}'
443enewuser() {
444 case ${EBUILD_PHASE} in
445 unpack|compile|test|install)
446 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
447 eerror "Package fails at QA and at life. Please file a bug."
448 die "Bad package! enewuser is only for use in pkg_* functions!"
449 esac
450
451 # get the username
452 local euser=$1; shift
453 if [[ -z ${euser} ]] ; then
454 eerror "No username specified !"
455 die "Cannot call enewuser without a username"
456 fi
457
458 # lets see if the username already exists
459 if [[ -n $(egetent passwd "${euser}") ]] ; then
460 return 0
461 fi
462 einfo "Adding user '${euser}' to your system ..."
463
464 # options to pass to useradd
465 local opts=
466
467 # handle uid
468 local euid=$1; shift
469 if [[ -n ${euid} && ${euid} != -1 ]] ; then
470 if [[ ${euid} -gt 0 ]] ; then
471 if [[ -n $(egetent passwd ${euid}) ]] ; then
472 euid="next"
473 fi 596 fi
474 else
475 eerror "Userid given but is not greater than 0 !"
476 die "${euid} is not a valid UID"
477 fi 597 fi
478 else
479 euid="next"
480 fi
481 if [[ ${euid} == "next" ]] ; then
482 for ((euid = 101; euid <= 999; euid++)); do
483 [[ -z $(egetent passwd ${euid}) ]] && break
484 done
485 fi
486 opts="${opts} -u ${euid}"
487 einfo " - Userid: ${euid}"
488
489 # handle shell
490 local eshell=$1; shift
491 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
492 if [[ ! -e ${ROOT}${eshell} ]] ; then
493 eerror "A shell was specified but it does not exist !"
494 die "${eshell} does not exist in ${ROOT}"
495 fi
496 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
497 eerror "Do not specify ${eshell} yourself, use -1"
498 die "Pass '-1' as the shell parameter"
499 fi
500 else
501 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
502 [[ -x ${ROOT}${shell} ]] && break
503 done
504
505 if [[ ${shell} == "/dev/null" ]] ; then
506 eerror "Unable to identify the shell to use, proceeding with userland default."
507 case ${USERLAND} in
508 GNU) shell="/bin/false" ;;
509 BSD) shell="/sbin/nologin" ;;
510 Darwin) shell="/usr/sbin/nologin" ;;
511 *) die "Unable to identify the default shell for userland ${USERLAND}"
512 esac
513 fi
514
515 eshell=${shell}
516 fi
517 einfo " - Shell: ${eshell}"
518 opts="${opts} -s ${eshell}"
519
520 # handle homedir
521 local ehome=$1; shift
522 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
523 ehome="/dev/null"
524 fi
525 einfo " - Home: ${ehome}"
526 opts="${opts} -d ${ehome}"
527
528 # handle groups
529 local egroups=$1; shift
530 if [[ ! -z ${egroups} ]] ; then
531 local oldifs=${IFS}
532 local defgroup="" exgroups=""
533
534 export IFS=","
535 for g in ${egroups} ; do
536 export IFS=${oldifs}
537 if [[ -z $(egetent group "${g}") ]] ; then
538 eerror "You must add group ${g} to the system first"
539 die "${g} is not a valid GID"
540 fi
541 if [[ -z ${defgroup} ]] ; then
542 defgroup=${g}
543 else
544 exgroups="${exgroups},${g}"
545 fi
546 export IFS=","
547 done
548 export IFS=${oldifs}
549
550 opts="${opts} -g ${defgroup}"
551 if [[ ! -z ${exgroups} ]] ; then
552 opts="${opts} -G ${exgroups:1}"
553 fi
554 else
555 egroups="(none)"
556 fi
557 einfo " - Groups: ${egroups}"
558
559 # handle extra and add the user
560 local oldsandbox=${SANDBOX_ON}
561 export SANDBOX_ON="0"
562 case ${CHOST} in
563 *-darwin*)
564 ### Make the user
565 if [[ -z $@ ]] ; then
566 dscl . create /users/${euser} uid ${euid}
567 dscl . create /users/${euser} shell ${eshell}
568 dscl . create /users/${euser} home ${ehome}
569 dscl . create /users/${euser} realname "added by portage for ${PN}"
570 ### Add the user to the groups specified
571 local oldifs=${IFS}
572 export IFS=","
573 for g in ${egroups} ; do
574 dscl . merge /groups/${g} users ${euser}
575 done
576 export IFS=${oldifs}
577 else
578 einfo "Extra options are not supported on Darwin yet"
579 einfo "Please report the ebuild along with the info below"
580 einfo "eextra: $@"
581 die "Required function missing"
582 fi
583 ;;
584 *-freebsd*|*-dragonfly*)
585 if [[ -z $@ ]] ; then
586 pw useradd ${euser} ${opts} \
587 -c "added by portage for ${PN}" \
588 die "enewuser failed"
589 else
590 einfo " - Extra: $@"
591 pw useradd ${euser} ${opts} \
592 "$@" || die "enewuser failed"
593 fi
594 ;;
595
596 *-netbsd*)
597 if [[ -z $@ ]] ; then
598 useradd ${opts} ${euser} || die "enewuser failed"
599 else
600 einfo " - Extra: $@"
601 useradd ${opts} ${euser} "$@" || die "enewuser failed"
602 fi
603 ;;
604
605 *-openbsd*)
606 if [[ -z $@ ]] ; then
607 useradd -u ${euid} -s ${eshell} \
608 -d ${ehome} -c "Added by portage for ${PN}" \
609 -g ${egroups} ${euser} || die "enewuser failed"
610 else
611 einfo " - Extra: $@"
612 useradd -u ${euid} -s ${eshell} \
613 -d ${ehome} -c "Added by portage for ${PN}" \
614 -g ${egroups} ${euser} "$@" || die "enewuser failed"
615 fi
616 ;;
617
618 *)
619 if [[ -z $@ ]] ; then
620 useradd ${opts} ${euser} \
621 -c "added by portage for ${PN}" \
622 || die "enewuser failed"
623 else
624 einfo " - Extra: $@"
625 useradd ${opts} ${euser} "$@" \
626 || die "enewuser failed"
627 fi
628 ;;
629 esac
630
631 if [[ ! -e ${ROOT}/${ehome} ]] ; then
632 einfo " - Creating ${ehome} in ${ROOT}"
633 mkdir -p "${ROOT}/${ehome}"
634 chown ${euser} "${ROOT}/${ehome}"
635 chmod 755 "${ROOT}/${ehome}"
636 fi
637
638 export SANDBOX_ON=${oldsandbox}
639} 598}
640 599
641# Simplify/standardize adding groups to the system 600# @FUNCTION: edos2unix
642# vapier@gentoo.org 601# @USAGE: <file> [more files ...]
643# 602# @DESCRIPTION:
644# enewgroup(group, gid) 603# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
645# 604# to remove all of these text utilities from DEPEND variables because this
646# Default values if you do not specify any: 605# is a script based solution. Just give it a list of files to convert and
647# groupname: REQUIRED ! 606# they will all be changed from the DOS CRLF format to the UNIX LF format.
648# gid: next available (see groupadd(8))
649# extra: none
650enewgroup() {
651 case ${EBUILD_PHASE} in
652 unpack|compile|test|install)
653 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
654 eerror "Package fails at QA and at life. Please file a bug."
655 die "Bad package! enewgroup is only for use in pkg_* functions!"
656 esac
657
658 # get the group
659 local egroup="$1"; shift
660 if [ -z "${egroup}" ]
661 then
662 eerror "No group specified !"
663 die "Cannot call enewgroup without a group"
664 fi
665
666 # see if group already exists
667 if [[ -n $(egetent group "${egroup}") ]]; then
668 return 0
669 fi
670 einfo "Adding group '${egroup}' to your system ..."
671
672 # options to pass to useradd
673 local opts=
674
675 # handle gid
676 local egid="$1"; shift
677 if [ ! -z "${egid}" ]
678 then
679 if [ "${egid}" -gt 0 ]
680 then
681 if [ -z "`egetent group ${egid}`" ]
682 then
683 if [[ "${CHOST}" == *-darwin* ]]; then
684 opts="${opts} ${egid}"
685 else
686 opts="${opts} -g ${egid}"
687 fi
688 else
689 egid="next available; requested gid taken"
690 fi
691 else
692 eerror "Groupid given but is not greater than 0 !"
693 die "${egid} is not a valid GID"
694 fi
695 else
696 egid="next available"
697 fi
698 einfo " - Groupid: ${egid}"
699
700 # handle extra
701 local eextra="$@"
702 opts="${opts} ${eextra}"
703
704 # add the group
705 local oldsandbox="${SANDBOX_ON}"
706 export SANDBOX_ON="0"
707 case ${CHOST} in
708 *-darwin*)
709 if [ ! -z "${eextra}" ];
710 then
711 einfo "Extra options are not supported on Darwin/OS X yet"
712 einfo "Please report the ebuild along with the info below"
713 einfo "eextra: ${eextra}"
714 die "Required function missing"
715 fi
716
717 # If we need the next available
718 case ${egid} in
719 *[!0-9]*) # Non numeric
720 for ((egid = 101; egid <= 999; egid++)); do
721 [[ -z $(egetent group ${egid}) ]] && break
722 done
723 esac
724 dscl . create /groups/${egroup} gid ${egid}
725 dscl . create /groups/${egroup} passwd '*'
726 ;;
727
728 *-freebsd*|*-dragonfly*)
729 case ${egid} in
730 *[!0-9]*) # Non numeric
731 for ((egid = 101; egid <= 999; egid++)); do
732 [[ -z $(egetent group ${egid}) ]] && break
733 done
734 esac
735 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
736 ;;
737
738 *-netbsd*)
739 case ${egid} in
740 *[!0-9]*) # Non numeric
741 for ((egid = 101; egid <= 999; egid++)); do
742 [[ -z $(egetent group ${egid}) ]] && break
743 done
744 esac
745 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
746 ;;
747
748 *)
749 groupadd ${opts} ${egroup} || die "enewgroup failed"
750 ;;
751 esac
752 export SANDBOX_ON="${oldsandbox}"
753}
754
755# Simple script to replace 'dos2unix' binaries
756# vapier@gentoo.org
757#
758# edos2unix(file, <more files> ...)
759edos2unix() { 607edos2unix() {
760 echo "$@" | xargs sed -i 's/\r$//' 608 [[ $# -eq 0 ]] && return 0
609 sed -i 's/\r$//' -- "$@" || die
761} 610}
762 611
763 612# @FUNCTION: make_desktop_entry
764############################################################## 613# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
765# START: Handle .desktop files and menu entries # 614# @DESCRIPTION:
766# maybe this should be separated into a new eclass some time #
767# lanius@gentoo.org #
768##############################################################
769
770# Make a desktop file ! 615# Make a .desktop file.
771# Great for making those icons in kde/gnome startmenu !
772# Amaze your friends ! Get the women ! Join today !
773# 616#
774# make_desktop_entry(<command>, [name], [icon], [type], [path]) 617# @CODE
775#
776# binary: what command does the app run with ? 618# binary: what command does the app run with ?
777# name: the name that will show up in the menu 619# name: the name that will show up in the menu
778# icon: give your little like a pretty little icon ... 620# icon: give your little like a pretty little icon ...
779# this can be relative (to /usr/share/pixmaps) or 621# this can be relative (to /usr/share/pixmaps) or
780# a full path to an icon 622# a full path to an icon
781# type: what kind of application is this ? for categories: 623# type: what kind of application is this?
782# http://www.freedesktop.org/Standards/desktop-entry-spec 624# for categories:
783# path: if your app needs to startup in a specific dir 625# http://standards.freedesktop.org/menu-spec/latest/apa.html
626# if unset, function tries to guess from package's category
627# fields: extra fields to append to the desktop file; a printf string
628# @CODE
784make_desktop_entry() { 629make_desktop_entry() {
785 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 630 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
786 631
787 local exec=${1} 632 local exec=${1}
788 local name=${2:-${PN}} 633 local name=${2:-${PN}}
789 local icon=${3:-${PN}.png} 634 local icon=${3:-${PN}}
790 local type=${4} 635 local type=${4}
791 local path=${5} 636 local fields=${5}
792 637
793 if [[ -z ${type} ]] ; then 638 if [[ -z ${type} ]] ; then
794 local catmaj=${CATEGORY%%-*} 639 local catmaj=${CATEGORY%%-*}
795 local catmin=${CATEGORY##*-} 640 local catmin=${CATEGORY##*-}
796 case ${catmaj} in 641 case ${catmaj} in
797 app) 642 app)
798 case ${catmin} in 643 case ${catmin} in
644 accessibility) type=Accessibility;;
799 admin) type=System;; 645 admin) type=System;;
646 antivirus) type=System;;
647 arch) type=Archiving;;
648 backup) type=Archiving;;
800 cdr) type=DiscBurning;; 649 cdr) type=DiscBurning;;
801 dicts) type=Dictionary;; 650 dicts) type=Dictionary;;
651 doc) type=Documentation;;
802 editors) type=TextEditor;; 652 editors) type=TextEditor;;
803 emacs) type=TextEditor;; 653 emacs) type=TextEditor;;
804 emulation) type=Emulator;; 654 emulation) type=Emulator;;
805 laptop) type=HardwareSettings;; 655 laptop) type=HardwareSettings;;
806 office) type=Office;; 656 office) type=Office;;
657 pda) type=PDA;;
807 vim) type=TextEditor;; 658 vim) type=TextEditor;;
808 xemacs) type=TextEditor;; 659 xemacs) type=TextEditor;;
809 *) type=;;
810 esac 660 esac
811 ;; 661 ;;
812 662
813 dev) 663 dev)
814 type="Development" 664 type="Development"
815 ;; 665 ;;
816 666
817 games) 667 games)
818 case ${catmin} in 668 case ${catmin} in
819 action|fps) type=ActionGame;; 669 action|fps) type=ActionGame;;
820 arcade) type=ArcadeGame;; 670 arcade) type=ArcadeGame;;
821 board) type=BoardGame;; 671 board) type=BoardGame;;
822 kids) type=KidsGame;;
823 emulation) type=Emulator;; 672 emulation) type=Emulator;;
673 kids) type=KidsGame;;
824 puzzle) type=LogicGame;; 674 puzzle) type=LogicGame;;
825 rpg) type=RolePlaying;;
826 roguelike) type=RolePlaying;; 675 roguelike) type=RolePlaying;;
676 rpg) type=RolePlaying;;
827 simulation) type=Simulation;; 677 simulation) type=Simulation;;
828 sports) type=SportsGame;; 678 sports) type=SportsGame;;
829 strategy) type=StrategyGame;; 679 strategy) type=StrategyGame;;
830 *) type=;;
831 esac 680 esac
832 type="Game;${type}" 681 type="Game;${type}"
833 ;; 682 ;;
834 683
684 gnome)
685 type="Gnome;GTK"
686 ;;
687
688 kde)
689 type="KDE;Qt"
690 ;;
691
835 mail) 692 mail)
836 type="Network;Email" 693 type="Network;Email"
837 ;; 694 ;;
838 695
839 media) 696 media)
840 case ${catmin} in 697 case ${catmin} in
698 gfx)
841 gfx) type=Graphics;; 699 type=Graphics
700 ;;
701 *)
702 case ${catmin} in
842 radio) type=Tuner;; 703 radio) type=Tuner;;
843 sound) type=Audio;; 704 sound) type=Audio;;
844 tv) type=TV;; 705 tv) type=TV;;
845 video) type=Video;; 706 video) type=Video;;
846 *) type=;; 707 esac
708 type="AudioVideo;${type}"
709 ;;
847 esac 710 esac
848 type="AudioVideo;${type}"
849 ;; 711 ;;
850 712
851 net) 713 net)
852 case ${catmin} in 714 case ${catmin} in
853 dialup) type=Dialup;; 715 dialup) type=Dialup;;
854 ftp) type=FileTransfer;; 716 ftp) type=FileTransfer;;
855 im) type=InstantMessaging;; 717 im) type=InstantMessaging;;
856 irc) type=IRCClient;; 718 irc) type=IRCClient;;
857 mail) type=Email;; 719 mail) type=Email;;
858 news) type=News;; 720 news) type=News;;
859 nntp) type=News;; 721 nntp) type=News;;
860 p2p) type=FileTransfer;; 722 p2p) type=FileTransfer;;
861 *) type=;; 723 voip) type=Telephony;;
862 esac 724 esac
863 type="Network;${type}" 725 type="Network;${type}"
864 ;; 726 ;;
865 727
866 sci) 728 sci)
867 case ${catmin} in 729 case ${catmin} in
868 astro*) type=Astronomy;; 730 astro*) type=Astronomy;;
869 bio*) type=Biology;; 731 bio*) type=Biology;;
870 calc*) type=Calculator;; 732 calc*) type=Calculator;;
871 chem*) type=Chemistry;; 733 chem*) type=Chemistry;;
734 elec*) type=Electronics;;
872 geo*) type=Geology;; 735 geo*) type=Geology;;
873 math*) type=Math;; 736 math*) type=Math;;
874 *) type=;; 737 physics) type=Physics;;
738 visual*) type=DataVisualization;;
875 esac 739 esac
876 type="Science;${type}" 740 type="Education;Science;${type}"
741 ;;
742
743 sys)
744 type="System"
877 ;; 745 ;;
878 746
879 www) 747 www)
880 case ${catmin} in 748 case ${catmin} in
881 client) type=WebBrowser;; 749 client) type=WebBrowser;;
882 *) type=;;
883 esac 750 esac
884 type="Network" 751 type="Network;${type}"
885 ;; 752 ;;
886 753
887 *) 754 *)
888 type= 755 type=
889 ;; 756 ;;
895 local desktop_name="${PN}-${SLOT}" 762 local desktop_name="${PN}-${SLOT}"
896 fi 763 fi
897 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 764 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
898 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 765 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
899 766
767 # Don't append another ";" when a valid category value is provided.
768 type=${type%;}${type:+;}
769
770 eshopts_push -s extglob
771 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
772 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
773 ewarn "allowed in .desktop files if the value is not an absolute path."
774 icon=${icon%.@(xpm|png|svg)}
775 fi
776 eshopts_pop
777
900 cat <<-EOF > "${desktop}" 778 cat <<-EOF > "${desktop}"
901 [Desktop Entry] 779 [Desktop Entry]
902 Encoding=UTF-8
903 Version=0.9.2
904 Name=${name} 780 Name=${name}
905 Type=Application 781 Type=Application
906 Comment=${DESCRIPTION} 782 Comment=${DESCRIPTION}
907 Exec=${exec} 783 Exec=${exec}
908 TryExec=${exec%% *} 784 TryExec=${exec%% *}
909 Path=${path}
910 Icon=${icon} 785 Icon=${icon}
911 Categories=Application;${type}; 786 Categories=${type}
912 EOF 787 EOF
788
789 if [[ ${fields:-=} != *=* ]] ; then
790 # 5th arg used to be value to Path=
791 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
792 fields="Path=${fields}"
793 fi
794 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
913 795
914 ( 796 (
915 # wrap the env here so that the 'insinto' call 797 # wrap the env here so that the 'insinto' call
916 # doesn't corrupt the env of the caller 798 # doesn't corrupt the env of the caller
917 insinto /usr/share/applications 799 insinto /usr/share/applications
918 doins "${desktop}" 800 doins "${desktop}"
919 ) 801 ) || die "installing desktop file failed"
920} 802}
921 803
922# Make a GDM/KDM Session file 804# @FUNCTION: validate_desktop_entries
923# 805# @USAGE: [directories]
924# make_session_desktop(<title>, <command>) 806# @MAINTAINER:
925# title: File to execute to start the Window Manager 807# Carsten Lohrke <carlo@gentoo.org>
926# command: Name of the Window Manager 808# @DESCRIPTION:
809# Validate desktop entries using desktop-file-utils
810validate_desktop_entries() {
811 if [[ -x /usr/bin/desktop-file-validate ]] ; then
812 einfo "Checking desktop entry validity"
813 local directories=""
814 for d in /usr/share/applications $@ ; do
815 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
816 done
817 if [[ -n ${directories} ]] ; then
818 for FILE in $(find ${directories} -name "*\.desktop" \
819 -not -path '*.hidden*' | sort -u 2>/dev/null)
820 do
821 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
822 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
823 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
824 done
825 fi
826 echo ""
827 else
828 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
829 fi
830}
927 831
832# @FUNCTION: make_session_desktop
833# @USAGE: <title> <command> [command args...]
834# @DESCRIPTION:
835# Make a GDM/KDM Session file. The title is the file to execute to start the
836# Window Manager. The command is the name of the Window Manager.
837#
838# You can set the name of the file via the ${wm} variable.
928make_session_desktop() { 839make_session_desktop() {
929 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 840 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
930 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 841 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
931 842
932 local title=$1 843 local title=$1
933 local command=$2 844 local command=$2
934 local desktop=${T}/${wm}.desktop 845 local desktop=${T}/${wm:-${PN}}.desktop
846 shift 2
935 847
936 cat <<-EOF > "${desktop}" 848 cat <<-EOF > "${desktop}"
937 [Desktop Entry] 849 [Desktop Entry]
938 Encoding=UTF-8
939 Name=${title} 850 Name=${title}
940 Comment=This session logs you into ${title} 851 Comment=This session logs you into ${title}
941 Exec=${command} 852 Exec=${command} $*
942 TryExec=${command} 853 TryExec=${command}
943 Type=Application 854 Type=XSession
944 EOF 855 EOF
945 856
946 ( 857 (
947 # wrap the env here so that the 'insinto' call 858 # wrap the env here so that the 'insinto' call
948 # doesn't corrupt the env of the caller 859 # doesn't corrupt the env of the caller
949 insinto /usr/share/xsessions 860 insinto /usr/share/xsessions
950 doins "${desktop}" 861 doins "${desktop}"
951 ) 862 )
952} 863}
953 864
865# @FUNCTION: domenu
866# @USAGE: <menus>
867# @DESCRIPTION:
868# Install the list of .desktop menu files into the appropriate directory
869# (/usr/share/applications).
954domenu() { 870domenu() {
955 ( 871 (
956 # wrap the env here so that the 'insinto' call 872 # wrap the env here so that the 'insinto' call
957 # doesn't corrupt the env of the caller 873 # doesn't corrupt the env of the caller
958 local i j ret=0 874 local i j ret=0
964 elif [[ -d ${i} ]] ; then 880 elif [[ -d ${i} ]] ; then
965 for j in "${i}"/*.desktop ; do 881 for j in "${i}"/*.desktop ; do
966 doins "${j}" 882 doins "${j}"
967 ((ret+=$?)) 883 ((ret+=$?))
968 done 884 done
885 else
886 ((++ret))
969 fi 887 fi
970 done 888 done
971 exit ${ret} 889 exit ${ret}
972 ) 890 )
973} 891}
892
893# @FUNCTION: newmenu
894# @USAGE: <menu> <newname>
895# @DESCRIPTION:
896# Like all other new* functions, install the specified menu as newname.
974newmenu() { 897newmenu() {
975 ( 898 (
976 # wrap the env here so that the 'insinto' call 899 # wrap the env here so that the 'insinto' call
977 # doesn't corrupt the env of the caller 900 # doesn't corrupt the env of the caller
978 insinto /usr/share/applications 901 insinto /usr/share/applications
979 newins "$@" 902 newins "$@"
980 ) 903 )
981} 904}
982 905
906# @FUNCTION: doicon
907# @USAGE: <list of icons>
908# @DESCRIPTION:
909# Install the list of icons into the icon directory (/usr/share/pixmaps).
910# This is useful in conjunction with creating desktop/menu files.
983doicon() { 911doicon() {
984 ( 912 (
985 # wrap the env here so that the 'insinto' call 913 # wrap the env here so that the 'insinto' call
986 # doesn't corrupt the env of the caller 914 # doesn't corrupt the env of the caller
987 local i j ret 915 local i j ret
993 elif [[ -d ${i} ]] ; then 921 elif [[ -d ${i} ]] ; then
994 for j in "${i}"/*.png ; do 922 for j in "${i}"/*.png ; do
995 doins "${j}" 923 doins "${j}"
996 ((ret+=$?)) 924 ((ret+=$?))
997 done 925 done
926 else
927 ((++ret))
998 fi 928 fi
999 done 929 done
1000 exit ${ret} 930 exit ${ret}
1001 ) 931 )
1002} 932}
933
934# @FUNCTION: newicon
935# @USAGE: <icon> <newname>
936# @DESCRIPTION:
937# Like all other new* functions, install the specified icon as newname.
1003newicon() { 938newicon() {
1004 ( 939 (
1005 # wrap the env here so that the 'insinto' call 940 # wrap the env here so that the 'insinto' call
1006 # doesn't corrupt the env of the caller 941 # doesn't corrupt the env of the caller
1007 insinto /usr/share/pixmaps 942 insinto /usr/share/pixmaps
1008 newins "$@" 943 newins "$@"
1009 ) 944 )
1010} 945}
1011
1012##############################################################
1013# END: Handle .desktop files and menu entries #
1014##############################################################
1015
1016 946
1017# for internal use only (unpack_pdv and unpack_makeself) 947# for internal use only (unpack_pdv and unpack_makeself)
1018find_unpackable_file() { 948find_unpackable_file() {
1019 local src=$1 949 local src=$1
1020 if [[ -z ${src} ]] ; then 950 if [[ -z ${src} ]] ; then
1030 fi 960 fi
1031 [[ ! -e ${src} ]] && return 1 961 [[ ! -e ${src} ]] && return 1
1032 echo "${src}" 962 echo "${src}"
1033} 963}
1034 964
965# @FUNCTION: unpack_pdv
966# @USAGE: <file to unpack> <size of off_t>
967# @DESCRIPTION:
1035# Unpack those pesky pdv generated files ... 968# Unpack those pesky pdv generated files ...
1036# They're self-unpacking programs with the binary package stuffed in 969# They're self-unpacking programs with the binary package stuffed in
1037# the middle of the archive. Valve seems to use it a lot ... too bad 970# the middle of the archive. Valve seems to use it a lot ... too bad
1038# it seems to like to segfault a lot :(. So lets take it apart ourselves. 971# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1039# 972#
1040# Usage: unpack_pdv [file to unpack] [size of off_t]
1041# - you have to specify the off_t size ... i have no idea how to extract that 973# You have to specify the off_t size ... I have no idea how to extract that
1042# information out of the binary executable myself. basically you pass in 974# information out of the binary executable myself. Basically you pass in
1043# the size of the off_t type (in bytes) on the machine that built the pdv 975# the size of the off_t type (in bytes) on the machine that built the pdv
976# archive.
977#
1044# archive. one way to determine this is by running the following commands: 978# One way to determine this is by running the following commands:
979#
980# @CODE
1045# strings <pdv archive> | grep lseek 981# strings <pdv archive> | grep lseek
1046# strace -elseek <pdv archive> 982# strace -elseek <pdv archive>
983# @CODE
984#
1047# basically look for the first lseek command (we do the strings/grep because 985# Basically look for the first lseek command (we do the strings/grep because
1048# sometimes the function call is _llseek or something) and steal the 2nd 986# sometimes the function call is _llseek or something) and steal the 2nd
1049# parameter. here is an example: 987# parameter. Here is an example:
988#
989# @CODE
1050# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 990# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1051# lseek 991# lseek
1052# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 992# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1053# lseek(3, -4, SEEK_END) = 2981250 993# lseek(3, -4, SEEK_END) = 2981250
994# @CODE
995#
1054# thus we would pass in the value of '4' as the second parameter. 996# Thus we would pass in the value of '4' as the second parameter.
1055unpack_pdv() { 997unpack_pdv() {
1056 local src=$(find_unpackable_file "$1") 998 local src=$(find_unpackable_file "$1")
1057 local sizeoff_t=$2 999 local sizeoff_t=$2
1058 1000
1059 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1001 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1121 true 1063 true
1122 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1064 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1123 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1065 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1124} 1066}
1125 1067
1068# @FUNCTION: unpack_makeself
1069# @USAGE: [file to unpack] [offset] [tail|dd]
1070# @DESCRIPTION:
1126# Unpack those pesky makeself generated files ... 1071# Unpack those pesky makeself generated files ...
1127# They're shell scripts with the binary package tagged onto 1072# They're shell scripts with the binary package tagged onto
1128# the end of the archive. Loki utilized the format as does 1073# the end of the archive. Loki utilized the format as does
1129# many other game companies. 1074# many other game companies.
1130# 1075#
1131# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1076# If the file is not specified, then ${A} is used. If the
1132# - If the file is not specified then unpack will utilize ${A}.
1133# - If the offset is not specified then we will attempt to extract 1077# offset is not specified then we will attempt to extract
1134# the proper offset from the script itself. 1078# the proper offset from the script itself.
1135unpack_makeself() { 1079unpack_makeself() {
1136 local src_input=${1:-${A}} 1080 local src_input=${1:-${A}}
1137 local src=$(find_unpackable_file "${src_input}") 1081 local src=$(find_unpackable_file "${src_input}")
1138 local skip=$2 1082 local skip=$2
1139 local exe=$3 1083 local exe=$3
1141 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1085 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1142 1086
1143 local shrtsrc=$(basename "${src}") 1087 local shrtsrc=$(basename "${src}")
1144 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1088 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1145 if [[ -z ${skip} ]] ; then 1089 if [[ -z ${skip} ]] ; then
1146 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1090 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1147 local skip=0 1091 local skip=0
1148 exe=tail 1092 exe=tail
1149 case ${ver} in 1093 case ${ver} in
1150 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1094 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1151 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1095 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1153 2.0|2.0.1) 1097 2.0|2.0.1)
1154 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1098 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1155 ;; 1099 ;;
1156 2.1.1) 1100 2.1.1)
1157 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1101 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1158 let skip="skip + 1" 1102 (( skip++ ))
1159 ;; 1103 ;;
1160 2.1.2) 1104 2.1.2)
1161 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1105 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1162 let skip="skip + 1" 1106 (( skip++ ))
1163 ;; 1107 ;;
1164 2.1.3) 1108 2.1.3)
1165 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1109 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1166 let skip="skip + 1" 1110 (( skip++ ))
1167 ;; 1111 ;;
1168 2.1.4|2.1.5) 1112 2.1.4|2.1.5)
1169 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1113 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1170 skip=$(head -n ${skip} "${src}" | wc -c) 1114 skip=$(head -n ${skip} "${src}" | wc -c)
1171 exe="dd" 1115 exe="dd"
1180 esac 1124 esac
1181 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1125 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1182 fi 1126 fi
1183 case ${exe} in 1127 case ${exe} in
1184 tail) exe="tail -n +${skip} '${src}'";; 1128 tail) exe="tail -n +${skip} '${src}'";;
1185 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1129 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1186 *) die "makeself cant handle exe '${exe}'" 1130 *) die "makeself cant handle exe '${exe}'"
1187 esac 1131 esac
1188 1132
1189 # lets grab the first few bytes of the file to figure out what kind of archive it is 1133 # lets grab the first few bytes of the file to figure out what kind of archive it is
1190 local tmpfile=$(emktemp) 1134 local filetype tmpfile=$(emktemp)
1191 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1135 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1192 local filetype=$(file -b "${tmpfile}") 1136 filetype=$(file -b "${tmpfile}") || die
1193 case ${filetype} in 1137 case ${filetype} in
1194 *tar\ archive*) 1138 *tar\ archive*)
1195 eval ${exe} | tar --no-same-owner -xf - 1139 eval ${exe} | tar --no-same-owner -xf -
1196 ;; 1140 ;;
1197 bzip2*) 1141 bzip2*)
1209 ;; 1153 ;;
1210 esac 1154 esac
1211 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1155 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1212} 1156}
1213 1157
1214# Display a license for user to accept. 1158# @FUNCTION: cdrom_get_cds
1215# 1159# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1216# Usage: check_license [license] 1160# @DESCRIPTION:
1217# - If the file is not specified then ${LICENSE} is used.
1218check_license() {
1219 local lic=$1
1220 if [ -z "${lic}" ] ; then
1221 lic="${PORTDIR}/licenses/${LICENSE}"
1222 else
1223 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1224 lic="${PORTDIR}/licenses/${lic}"
1225 elif [ -e "${PWD}/${lic}" ] ; then
1226 lic="${PWD}/${lic}"
1227 elif [ -e "${lic}" ] ; then
1228 lic="${lic}"
1229 fi
1230 fi
1231 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1232 local l="`basename ${lic}`"
1233
1234 # here is where we check for the licenses the user already
1235 # accepted ... if we don't find a match, we make the user accept
1236 local shopts=$-
1237 local alic
1238 set -o noglob #so that bash doesn't expand "*"
1239 for alic in ${ACCEPT_LICENSE} ; do
1240 if [[ ${alic} == ${l} ]]; then
1241 set +o noglob; set -${shopts} #reset old shell opts
1242 return 0
1243 fi
1244 done
1245 set +o noglob; set -$shopts #reset old shell opts
1246
1247 local licmsg=$(emktemp)
1248 cat <<-EOF > ${licmsg}
1249 **********************************************************
1250 The following license outlines the terms of use of this
1251 package. You MUST accept this license for installation to
1252 continue. When you are done viewing, hit 'q'. If you
1253 CTRL+C out of this, the install will not run!
1254 **********************************************************
1255
1256 EOF
1257 cat ${lic} >> ${licmsg}
1258 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1259 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1260 read alic
1261 case ${alic} in
1262 yes|Yes|y|Y)
1263 return 0
1264 ;;
1265 *)
1266 echo;echo;echo
1267 eerror "You MUST accept the license to continue! Exiting!"
1268 die "Failed to accept license"
1269 ;;
1270 esac
1271}
1272
1273# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1161# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1274# the whole 'non-interactive' policy, but damnit I want CD support ! 1162# the whole 'non-interactive' policy, but damnit I want CD support !
1275# 1163#
1276# with these cdrom functions we handle all the user interaction and 1164# With these cdrom functions we handle all the user interaction and
1277# standardize everything. all you have to do is call cdrom_get_cds() 1165# standardize everything. All you have to do is call cdrom_get_cds()
1278# and when the function returns, you can assume that the cd has been 1166# and when the function returns, you can assume that the cd has been
1279# found at CDROM_ROOT. 1167# found at CDROM_ROOT.
1280# 1168#
1169# The function will attempt to locate a cd based upon a file that is on
1170# the cd. The more files you give this function, the more cds
1171# the cdrom functions will handle.
1172#
1281# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1173# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1282# etc... if you want to give the cds better names, then just export 1174# etc... If you want to give the cds better names, then just export
1283# the appropriate CDROM_NAME variable before calling cdrom_get_cds(). 1175# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1284# - CDROM_NAME="fooie cd" - for when you only want 1 cd 1176# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1285# - CDROM_NAME_1="install cd" - for when you want more than 1 cd 1177# also use the CDROM_NAME_SET bash array.
1286# CDROM_NAME_2="data cd"
1287# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1288# 1178#
1289# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1179# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1290#
1291# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1292# - this will attempt to locate a cd based upon a file that is on
1293# the cd ... the more files you give this function, the more cds
1294# the cdrom functions will handle
1295cdrom_get_cds() { 1180cdrom_get_cds() {
1296 # first we figure out how many cds we're dealing with by 1181 # first we figure out how many cds we're dealing with by
1297 # the # of files they gave us 1182 # the # of files they gave us
1298 local cdcnt=0 1183 local cdcnt=0
1299 local f= 1184 local f=
1323 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1208 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1324 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1209 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1325 export CDROM_SET=-1 1210 export CDROM_SET=-1
1326 for f in ${CDROM_CHECK_1//:/ } ; do 1211 for f in ${CDROM_CHECK_1//:/ } ; do
1327 ((++CDROM_SET)) 1212 ((++CDROM_SET))
1328 [[ -e ${CD_ROOT}/${f} ]] && break 1213 [[ -e ${CDROM_ROOT}/${f} ]] && break
1329 done 1214 done
1330 export CDROM_MATCH=${f} 1215 export CDROM_MATCH=${f}
1331 return 1216 return
1332 fi 1217 fi
1333 1218
1385 export CDROM_SET="" 1270 export CDROM_SET=""
1386 export CDROM_CURRENT_CD=0 1271 export CDROM_CURRENT_CD=0
1387 cdrom_load_next_cd 1272 cdrom_load_next_cd
1388} 1273}
1389 1274
1390# this is only used when you need access to more than one cd. 1275# @FUNCTION: cdrom_load_next_cd
1391# when you have finished using the first cd, just call this function. 1276# @DESCRIPTION:
1392# when it returns, CDROM_ROOT will be pointing to the second cd. 1277# Some packages are so big they come on multiple CDs. When you're done reading
1393# remember, you can only go forward in the cd chain, you can't go back. 1278# files off a CD and want access to the next one, just call this function.
1279# Again, all the messy details of user interaction are taken care of for you.
1280# Once this returns, just read the variable CDROM_ROOT for the location of the
1281# mounted CD. Note that you can only go forward in the CD list, so make sure
1282# you only call this function when you're done using the current CD.
1394cdrom_load_next_cd() { 1283cdrom_load_next_cd() {
1395 local var 1284 local var
1396 ((++CDROM_CURRENT_CD)) 1285 ((++CDROM_CURRENT_CD))
1397 1286
1398 unset CDROM_ROOT 1287 unset CDROM_ROOT
1415# displayed and we'll hang out here until: 1304# displayed and we'll hang out here until:
1416# (1) the file is found on a mounted cdrom 1305# (1) the file is found on a mounted cdrom
1417# (2) the user hits CTRL+C 1306# (2) the user hits CTRL+C
1418_cdrom_locate_file_on_cd() { 1307_cdrom_locate_file_on_cd() {
1419 local mline="" 1308 local mline=""
1420 local showedmsg=0 1309 local showedmsg=0 showjolietmsg=0
1421 1310
1422 while [[ -z ${CDROM_ROOT} ]] ; do 1311 while [[ -z ${CDROM_ROOT} ]] ; do
1423 local i=0 1312 local i=0
1424 local -a cdset=(${*//:/ }) 1313 local -a cdset=(${*//:/ })
1425 if [[ -n ${CDROM_SET} ]] ; then 1314 if [[ -n ${CDROM_SET} ]] ; then
1430 local dir=$(dirname ${cdset[${i}]}) 1319 local dir=$(dirname ${cdset[${i}]})
1431 local file=$(basename ${cdset[${i}]}) 1320 local file=$(basename ${cdset[${i}]})
1432 1321
1433 local point= node= fs= foo= 1322 local point= node= fs= foo=
1434 while read point node fs foo ; do 1323 while read point node fs foo ; do
1435 [[ " cd9660 iso9660 " != *" ${fs} "* ]] && \ 1324 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1436 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \ 1325 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1437 && continue 1326 && continue
1438 point=${point//\040/ } 1327 point=${point//\040/ }
1328 [[ ! -d ${point}/${dir} ]] && continue
1439 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue 1329 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1440 export CDROM_ROOT=${point} 1330 export CDROM_ROOT=${point}
1441 export CDROM_SET=${i} 1331 export CDROM_SET=${i}
1442 export CDROM_MATCH=${cdset[${i}]} 1332 export CDROM_MATCH=${cdset[${i}]}
1443 return 1333 return
1465 showedmsg=1 1355 showedmsg=1
1466 fi 1356 fi
1467 einfo "Press return to scan for the cd again" 1357 einfo "Press return to scan for the cd again"
1468 einfo "or hit CTRL+C to abort the emerge." 1358 einfo "or hit CTRL+C to abort the emerge."
1469 echo 1359 echo
1360 if [[ ${showjolietmsg} -eq 0 ]] ; then
1361 showjolietmsg=1
1362 else
1470 einfo "If you are having trouble with the detection" 1363 ewarn "If you are having trouble with the detection"
1471 einfo "of your CD, it is possible that you do not have" 1364 ewarn "of your CD, it is possible that you do not have"
1472 einfo "Joliet support enabled in your kernel. Please" 1365 ewarn "Joliet support enabled in your kernel. Please"
1473 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1366 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1367 ebeep 5
1368 fi
1474 read || die "something is screwed with your system" 1369 read || die "something is screwed with your system"
1475 done 1370 done
1476} 1371}
1477 1372
1373# @FUNCTION: strip-linguas
1374# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1375# @DESCRIPTION:
1478# Make sure that LINGUAS only contains languages that 1376# Make sure that LINGUAS only contains languages that
1479# a package can support 1377# a package can support. The first form allows you to
1480# 1378# specify a list of LINGUAS. The -i builds a list of po
1481# usage: strip-linguas <allow LINGUAS> 1379# files found in all the directories and uses the
1482# strip-linguas -i <directories of .po files> 1380# intersection of the lists. The -u builds a list of po
1483# strip-linguas -u <directories of .po files> 1381# files found in all the directories and uses the union
1484# 1382# of the lists.
1485# The first form allows you to specify a list of LINGUAS.
1486# The -i builds a list of po files found in all the
1487# directories and uses the intersection of the lists.
1488# The -u builds a list of po files found in all the
1489# directories and uses the union of the lists.
1490strip-linguas() { 1383strip-linguas() {
1491 local ls newls nols 1384 local ls newls nols
1492 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1385 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1493 local op=$1; shift 1386 local op=$1; shift
1494 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1387 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1495 local d f 1388 local d f
1496 for d in "$@" ; do 1389 for d in "$@" ; do
1497 if [[ ${op} == "-u" ]] ; then 1390 if [[ ${op} == "-u" ]] ; then
1498 newls=${ls} 1391 newls=${ls}
1499 else 1392 else
1500 newls="" 1393 newls=""
1501 fi 1394 fi
1502 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1395 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1503 if [[ ${op} == "-i" ]] ; then 1396 if [[ ${op} == "-i" ]] ; then
1504 hasq ${f} ${ls} && newls="${newls} ${f}" 1397 has ${f} ${ls} && newls="${newls} ${f}"
1505 else 1398 else
1506 hasq ${f} ${ls} || newls="${newls} ${f}" 1399 has ${f} ${ls} || newls="${newls} ${f}"
1507 fi 1400 fi
1508 done 1401 done
1509 ls=${newls} 1402 ls=${newls}
1510 done 1403 done
1511 else 1404 else
1513 fi 1406 fi
1514 1407
1515 nols="" 1408 nols=""
1516 newls="" 1409 newls=""
1517 for f in ${LINGUAS} ; do 1410 for f in ${LINGUAS} ; do
1518 if hasq ${f} ${ls} ; then 1411 if has ${f} ${ls} ; then
1519 newls="${newls} ${f}" 1412 newls="${newls} ${f}"
1520 else 1413 else
1521 nols="${nols} ${f}" 1414 nols="${nols} ${f}"
1522 fi 1415 fi
1523 done 1416 done
1524 [[ -n ${nols} ]] \ 1417 [[ -n ${nols} ]] \
1525 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1418 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1526 export LINGUAS=${newls:1} 1419 export LINGUAS=${newls:1}
1527} 1420}
1528 1421
1529# moved from kernel.eclass since they are generally useful outside of 1422# @FUNCTION: preserve_old_lib
1530# kernel.eclass -iggy (20041002) 1423# @USAGE: <libs to preserve> [more libs]
1531 1424# @DESCRIPTION:
1532# the following functions are useful in kernel module ebuilds, etc.
1533# for an example see ivtv or drbd ebuilds
1534
1535# set's ARCH to match what the kernel expects
1536set_arch_to_kernel() {
1537 i=10
1538 while ((i--)) ; do
1539 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1540 done
1541 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1542 case ${ARCH} in
1543 x86) export ARCH="i386";;
1544 amd64) export ARCH="x86_64";;
1545 hppa) export ARCH="parisc";;
1546 mips) export ARCH="mips";;
1547 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1548 *) export ARCH="${ARCH}";;
1549 esac
1550}
1551
1552# set's ARCH back to what portage expects
1553set_arch_to_portage() {
1554 i=10
1555 while ((i--)) ; do
1556 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1557 done
1558 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1559}
1560
1561# Jeremy Huddleston <eradicator@gentoo.org>:
1562# preserve_old_lib /path/to/libblah.so.0
1563# preserve_old_lib_notify /path/to/libblah.so.0
1564#
1565# These functions are useful when a lib in your package changes --library. Such 1425# These functions are useful when a lib in your package changes ABI SONAME.
1566# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1426# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1567# would break packages that link against it. Most people get around this 1427# would break packages that link against it. Most people get around this
1568# by using the portage SLOT mechanism, but that is not always a relevant 1428# by using the portage SLOT mechanism, but that is not always a relevant
1569# solution, so instead you can add the following to your ebuilds: 1429# solution, so instead you can call this from pkg_preinst. See also the
1570# 1430# preserve_old_lib_notify function.
1571# pkg_preinst() {
1572# ...
1573# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1574# ...
1575# }
1576#
1577# pkg_postinst() {
1578# ...
1579# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1580# ...
1581# }
1582
1583preserve_old_lib() { 1431preserve_old_lib() {
1584 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then 1432 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1585 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1433 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1586# die "Invalid preserve_old_lib() usage" 1434 die "Invalid preserve_old_lib() usage"
1587 fi 1435 fi
1588 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1436 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1437
1438 # let portage worry about it
1439 has preserve-libs ${FEATURES} && return 0
1589 1440
1590 local lib dir 1441 local lib dir
1591 for lib in "$@" ; do 1442 for lib in "$@" ; do
1592 [[ -e ${ROOT}/${lib} ]] || continue 1443 [[ -e ${ROOT}/${lib} ]] || continue
1593 dir=${lib%/*} 1444 dir=${lib%/*}
1595 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed" 1446 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1596 touch "${D}"/${lib} 1447 touch "${D}"/${lib}
1597 done 1448 done
1598} 1449}
1599 1450
1451# @FUNCTION: preserve_old_lib_notify
1452# @USAGE: <libs to notify> [more libs]
1453# @DESCRIPTION:
1454# Spit helpful messages about the libraries preserved by preserve_old_lib.
1600preserve_old_lib_notify() { 1455preserve_old_lib_notify() {
1601 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1456 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1602 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1457 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1603# die "Invalid preserve_old_lib_notify() usage" 1458 die "Invalid preserve_old_lib_notify() usage"
1604 fi 1459 fi
1460
1461 # let portage worry about it
1462 has preserve-libs ${FEATURES} && return 0
1605 1463
1606 local lib notice=0 1464 local lib notice=0
1607 for lib in "$@" ; do 1465 for lib in "$@" ; do
1608 [[ -e ${ROOT}/${lib} ]] || continue 1466 [[ -e ${ROOT}/${lib} ]] || continue
1609 if [[ ${notice} -eq 0 ]] ; then 1467 if [[ ${notice} -eq 0 ]] ; then
1613 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1471 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1614 ewarn "in order to remove these old dependencies. If you do not have this" 1472 ewarn "in order to remove these old dependencies. If you do not have this"
1615 ewarn "helper program, simply emerge the 'gentoolkit' package." 1473 ewarn "helper program, simply emerge the 'gentoolkit' package."
1616 ewarn 1474 ewarn
1617 fi 1475 fi
1476 # temp hack for #348634 #357225
1477 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1618 ewarn " # revdep-rebuild --library ${lib##*/}" 1478 ewarn " # revdep-rebuild --library '${lib}'"
1619 done 1479 done
1480 if [[ ${notice} -eq 1 ]] ; then
1481 ewarn
1482 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1483 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1484 for lib in "$@" ; do
1485 ewarn " # rm '${lib}'"
1486 done
1487 fi
1620} 1488}
1621 1489
1622# Hack for people to figure out if a package was built with 1490# @FUNCTION: built_with_use
1623# certain USE flags
1624#
1625# Usage: built_with_use [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1491# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1626# ex: built_with_use xchat gtk2 1492# @DESCRIPTION:
1627# 1493#
1628# Flags: -a all USE flags should be utilized 1494# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1629# -o at least one USE flag should be utilized 1495#
1630# --missing peform the specified action if the flag is not in IUSE (true/false/die) 1496# A temporary hack until portage properly supports DEPENDing on USE
1631# --hidden USE flag we're checking is hidden expanded so it isnt in IUSE 1497# flags being enabled in packages. This will check to see if the specified
1632# Note: the default flag is '-a' 1498# DEPEND atom was built with the specified list of USE flags. The
1499# --missing option controls the behavior if called on a package that does
1500# not actually support the defined USE flags (aka listed in IUSE).
1501# The default is to abort (call die). The -a and -o flags control
1502# the requirements of the USE flags. They correspond to "and" and "or"
1503# logic. So the -a flag means all listed USE flags must be enabled
1504# while the -o flag means at least one of the listed IUSE flags must be
1505# enabled. The --hidden option is really for internal use only as it
1506# means the USE flag we're checking is hidden expanded, so it won't be found
1507# in IUSE like normal USE flags.
1508#
1509# Remember that this function isn't terribly intelligent so order of optional
1510# flags matter.
1633built_with_use() { 1511built_with_use() {
1634 local hidden="no" 1512 local hidden="no"
1635 if [[ $1 == "--hidden" ]] ; then 1513 if [[ $1 == "--hidden" ]] ; then
1636 hidden="yes" 1514 hidden="yes"
1637 shift 1515 shift
1666 die) die "Unable to determine what USE flags $PKG was built with";; 1544 die) die "Unable to determine what USE flags $PKG was built with";;
1667 esac 1545 esac
1668 fi 1546 fi
1669 1547
1670 if [[ ${hidden} == "no" ]] ; then 1548 if [[ ${hidden} == "no" ]] ; then
1671 local IUSE_BUILT=$(<${IUSEFILE}) 1549 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1672 # Don't check USE_EXPAND #147237 1550 # Don't check USE_EXPAND #147237
1673 local expand 1551 local expand
1674 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1552 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1675 if [[ $1 == ${expand}_* ]] ; then 1553 if [[ $1 == ${expand}_* ]] ; then
1676 expand="" 1554 expand=""
1677 break 1555 break
1678 fi 1556 fi
1679 done 1557 done
1680 if [[ -n ${expand} ]] ; then 1558 if [[ -n ${expand} ]] ; then
1681 if ! has $1 ${IUSE_BUILT} ; then 1559 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1682 case ${missing_action} in 1560 case ${missing_action} in
1683 true) return 0;; 1561 true) return 0;;
1684 false) return 1;; 1562 false) return 1;;
1685 die) die "$PKG does not actually support the $1 USE flag!";; 1563 die) die "$PKG does not actually support the $1 USE flag!";;
1686 esac 1564 esac
1698 shift 1576 shift
1699 done 1577 done
1700 [[ ${opt} = "-a" ]] 1578 [[ ${opt} = "-a" ]]
1701} 1579}
1702 1580
1581# @FUNCTION: epunt_cxx
1582# @USAGE: [dir to scan]
1583# @DESCRIPTION:
1703# Many configure scripts wrongly bail when a C++ compiler 1584# Many configure scripts wrongly bail when a C++ compiler could not be
1704# could not be detected. #73450 1585# detected. If dir is not specified, then it defaults to ${S}.
1586#
1587# http://bugs.gentoo.org/73450
1705epunt_cxx() { 1588epunt_cxx() {
1706 local dir=$1 1589 local dir=$1
1707 [[ -z ${dir} ]] && dir=${S} 1590 [[ -z ${dir} ]] && dir=${S}
1708 ebegin "Removing useless C++ checks" 1591 ebegin "Removing useless C++ checks"
1709 local f 1592 local f
1710 for f in $(find ${dir} -name configure) ; do 1593 find "${dir}" -name configure | while read f ; do
1711 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1594 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1712 done 1595 done
1713 eend 0 1596 eend 0
1714} 1597}
1715 1598
1716# make a wrapper script ... 1599# @FUNCTION: make_wrapper
1717# NOTE: this was originally games_make_wrapper, but I noticed other places where 1600# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1718# this could be used, so I have moved it here and made it not games-specific 1601# @DESCRIPTION:
1719# -- wolf31o2 1602# Create a shell wrapper script named wrapper in installpath
1720# $1 == wrapper name 1603# (defaults to the bindir) to execute target (default of wrapper) by
1721# $2 == binary to run 1604# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1722# $3 == directory to chdir before running binary 1605# libpaths followed by optionally changing directory to chdir.
1723# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1724# $5 == path for wrapper
1725make_wrapper() { 1606make_wrapper() {
1726 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1607 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1727 local tmpwrapper=$(emktemp) 1608 local tmpwrapper=$(emktemp)
1728 # We don't want to quote ${bin} so that people can pass complex 1609 # We don't want to quote ${bin} so that people can pass complex
1729 # things as $bin ... "./someprog --args" 1610 # things as $bin ... "./someprog --args"
1739fi 1620fi
1740exec ${bin} "\$@" 1621exec ${bin} "\$@"
1741EOF 1622EOF
1742 chmod go+rx "${tmpwrapper}" 1623 chmod go+rx "${tmpwrapper}"
1743 if [[ -n ${path} ]] ; then 1624 if [[ -n ${path} ]] ; then
1625 (
1744 exeinto "${path}" 1626 exeinto "${path}"
1745 newexe "${tmpwrapper}" "${wrapper}" 1627 newexe "${tmpwrapper}" "${wrapper}"
1628 ) || die
1746 else 1629 else
1747 newbin "${tmpwrapper}" "${wrapper}" 1630 newbin "${tmpwrapper}" "${wrapper}" || die
1631 fi
1632}
1633
1634# @FUNCTION: path_exists
1635# @USAGE: [-a|-o] <paths>
1636# @DESCRIPTION:
1637# Check if the specified paths exist. Works for all types of paths
1638# (files/dirs/etc...). The -a and -o flags control the requirements
1639# of the paths. They correspond to "and" and "or" logic. So the -a
1640# flag means all the paths must exist while the -o flag means at least
1641# one of the paths must exist. The default behavior is "and". If no
1642# paths are specified, then the return value is "false".
1643path_exists() {
1644 local opt=$1
1645 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1646
1647 # no paths -> return false
1648 # same behavior as: [[ -e "" ]]
1649 [[ $# -eq 0 ]] && return 1
1650
1651 local p r=0
1652 for p in "$@" ; do
1653 [[ -e ${p} ]]
1654 : $(( r += $? ))
1655 done
1656
1657 case ${opt} in
1658 -a) return $(( r != 0 )) ;;
1659 -o) return $(( r == $# )) ;;
1660 esac
1661}
1662
1663# @FUNCTION: in_iuse
1664# @USAGE: <flag>
1665# @DESCRIPTION:
1666# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1667# as necessary.
1668#
1669# Note that this function should not be used in the global scope.
1670in_iuse() {
1671 debug-print-function ${FUNCNAME} "${@}"
1672 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1673
1674 local flag=${1}
1675 local liuse=( ${IUSE} )
1676
1677 has "${flag}" "${liuse[@]#[+-]}"
1678}
1679
1680# @FUNCTION: use_if_iuse
1681# @USAGE: <flag>
1682# @DESCRIPTION:
1683# Return true if the given flag is in USE and IUSE.
1684#
1685# Note that this function should not be used in the global scope.
1686use_if_iuse() {
1687 in_iuse $1 || return 1
1688 use $1
1689}
1690
1691# @FUNCTION: usex
1692# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1693# @DESCRIPTION:
1694# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1695# otherwise echo [false output][false suffix] (defaults to "no").
1696usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1697
1698check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1699
1748 fi 1700fi
1749}

Legend:
Removed from v.1.275  
changed lines
  Added in v.1.377

  ViewVC Help
Powered by ViewVC 1.1.20